# Generated by Django 3.1.7 on 2021-03-31 08:28

import math
import re

from django.db import migrations, models
from django.core.management import call_command
import django.db.models.deletion


def forward_migrate_counts(apps, schema_editor):
    call_command("loaddata", "individuals.json")
    Count = apps.get_model("api", "Count")
    Event = apps.get_model("api", "Event")
    IndividualCount = apps.get_model("api", "IndividualCount")
    Individual = apps.get_model("api", "Individual")
    worker_individual = Individual.objects.get(label="worker")
    egg_individual = Individual.objects.get(label="egg")
    larva_individual = Individual.objects.get(label="larva")
    pupa_individual = Individual.objects.get(label="pupa")

    for count in Count.objects.all():
        event = Event.objects.create(
            created_on=count.created_on,
            category=count.category,
            colony=count.colony,
            notes=count.notes,
        )
        individuals_counts = [
            {"individual": worker_individual, "count": count.workers},
            {"individual": egg_individual, "count": math.ceil(count.brood / 3)},
            {"individual": larva_individual, "count": math.floor(count.brood / 3)},
            {"individual": pupa_individual, "count": math.floor(count.brood / 3)},
        ]
        for individual_count in individuals_counts:
            IndividualCount.objects.create(
                event=event,
                individual=individual_count["individual"],
                count=individual_count["count"],
            )
        count.delete()


def reverse_migrate_counts(apps, scheman_editor):
    Event = apps.get_model("api", "Event")
    Count = apps.get_model("api", "Count")
    EventCategory = apps.get_model("api", "EventCategory")
    Individual = apps.get_model("api", "Individual")
    IndividualCategory = apps.get_model("api", "IndividualCategory")

    worker_individual = Individual.objects.get(label="worker")
    brood_individual_category = IndividualCategory.objects.get(label="brood")
    count_event_category = EventCategory.objects.get(label="count")

    for event in Event.objects.exclude(individuals_counts__isnull=True):
        workers_count = 0
        brood_count = 0
        for individual_count in event.individuals_counts.all():
            if individual_count.individual == worker_individual:
                workers_count += individual_count.count
            elif individual_count.individual.category == brood_individual_category:
                brood_count += individual_count.count
        Count.objects.create(
            colony=event.colony,
            category=count_event_category,
            notes=event.notes,
            workers=workers_count,
            brood=brood_count,
        )
        event.delete()


def forward_migrate_event_colony_to_colonies(apps, schema_editor):
    Event = apps.get_model("api", "Event")
    merge_pattern = r"!merge:(?P<id>[0-9]+)(?P<notes>.*)"

    events = {}
    for event in Event.objects.all():
        merge_match = re.match(merge_pattern, event.notes, re.DOTALL | re.MULTILINE)

        if merge_match:

            id = merge_match.group("id")
            if id not in events:
                new_event = Event.objects.create(
                    created_on=event.created_on, category=event.category
                )
                events[id] = new_event
            else:
                new_event = events[id]

            notes = merge_match.group("notes").strip()
            if notes:
                new_event.notes = notes

            new_event.colonies.add(event.colony)
            event.delete()
            event = new_event

        else:
            event.colonies.add(event.colony)
            event.colony = None

        event.save()


def reverse_migrate_event_colony_to_colonies(apps, schema_editor):
    Event = apps.get_model("api", "Event")

    for event in Event.objects.all():
        if event.colonies.count() > 1:
            for colony in event.colonies.all():
                Event.objects.create(
                    created_on=event.created_on,
                    colony=colony,
                    category=event.category,
                    notes=event.notes,
                )
            event.delete()
        else:
            event.colony = event.colonies.get()
            event.save()


class Migration(migrations.Migration):

    dependencies = [
        ("api", "0001_initial"),
    ]

    operations = [
        migrations.RenameField(
            model_name="eventcategory",
            old_name="name",
            new_name="label",
        ),
        migrations.CreateModel(
            name="Individual",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("label", models.CharField(max_length=255)),
            ],
            options={
                "verbose_name": "individual",
                "verbose_name_plural": "individuals",
            },
        ),
        migrations.CreateModel(
            name="IndividualCount",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("count", models.IntegerField()),
                (
                    "event",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="individuals_counts",
                        to="api.event",
                    ),
                ),
                (
                    "individual",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.PROTECT,
                        related_name="+",
                        to="api.individual",
                    ),
                ),
            ],
            options={
                "verbose_name": "individual count",
                "verbose_name_plural": "individuals counts",
            },
        ),
        migrations.CreateModel(
            name="IndividualCategory",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("label", models.CharField(max_length=255)),
            ],
            options={
                "verbose_name": "individual category",
                "verbose_name_plural": "individuals categories",
            },
        ),
        migrations.AlterField(
            model_name="event",
            name="created_on",
            field=models.DateTimeField(default=django.utils.timezone.now),
        ),
        migrations.AddField(
            model_name="individual",
            name="category",
            field=models.ForeignKey(
                blank=True,
                default=None,
                null=True,
                on_delete=django.db.models.deletion.PROTECT,
                related_name="individuals",
                to="api.individualcategory",
            ),
        ),
        migrations.RunPython(
            code=forward_migrate_counts, reverse_code=reverse_migrate_counts
        ),
        migrations.AlterField(
            model_name="event",
            name="colony",
            field=models.ForeignKey(
                blank=True,
                default=None,
                null=True,
                on_delete=django.db.models.deletion.CASCADE,
                related_name="events_legacy",
                to="api.colony",
            ),
        ),
        migrations.AddField(
            model_name="event",
            name="colonies",
            field=models.ManyToManyField(related_name="events", to="api.Colony"),
        ),
        migrations.RunPython(
            code=forward_migrate_event_colony_to_colonies,
            reverse_code=reverse_migrate_event_colony_to_colonies,
        ),
    ]
